# -*- coding: utf-8 -*-
# (C) 2010, Ben "GreaseMonkey" Russell for Ludumdare #19.
# Licensed under GPLv3. See COPYING for details.

# Level compiler

import sys, struct

# here, have a translation table

fp = open(sys.argv[1],"rb")
s = fp.read()
fp.close()
s = s.replace("\r\n","\n").replace("\r","\n") # deal with stupid versions of newlines
l = []
for q in s.split("\n"):
	if len(q) > 0:
		l.append(q)

cmap = {}

lc = 0
while True:
	s = l.pop(0)
	lc += 1
	if s[0] == "M":
		break
	elif s[0] == "T":
		z = s.split(" ")
		cmap[z[1]] = eval(z[2])
	else:
		raise Exception("line %i: command not valid" % lc)

print "Map length:",len(l)
print "Char map:",cmap

fp = open(sys.argv[2],"wb")
fp.write(chr(len(l)))
for s in l[::-1]: # must be stored upside-down
	assert len(s) == 32
	q = [cmap[c] for c in s]
	while q:
		k = 0
		for i in xrange(len(q)):
			if q[0] == q[i]:
				k += 1
			else:
				break
		
		if k >= 19:
			fp.write(chr(q[0]))
			fp.write(chr(k+0xF0-19))
		elif k >= 3:
			fp.write(chr(q[0]))
			fp.write(chr(k+0x70-3))
		elif k >= 2:
			fp.write(chr(q[0]|0x80))
		else:
			fp.write(chr(q[0]))
		
		q = q[k:]
fp.close()
